# Generated by Django 5.0 on 2023-12-06 14:18

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Agent",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255)),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("ORGANIZATION", "Organization"),
                            ("PERSON", "Person"),
                            ("OTHER", "Other"),
                        ],
                        default="ORGANIZATION",
                        max_length=20,
                    ),
                ),
                ("mbox", models.EmailField(blank=True, max_length=254, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="Resource",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="DataTheme",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("code", models.CharField(max_length=10)),
                ("label", models.CharField(max_length=255)),
                ("description", models.TextField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="LicenceDocument",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("code", models.CharField(max_length=10, unique=True)),
                ("label", models.CharField(max_length=255)),
                ("url_general", models.URLField(null=True)),
                ("url_document", models.URLField(null=True)),
            ],
        ),
        migrations.CreateModel(
            name="MediaType",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("code", models.CharField(max_length=10)),
                ("extension", models.CharField(max_length=10)),
                ("media_type", models.CharField(max_length=50)),
                ("description", models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name="Dataset",
            fields=[
                (
                    "resource_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="dcat.resource",
                    ),
                ),
                ("title", models.CharField(max_length=255)),
                ("description", models.TextField()),
            ],
            bases=("dcat.resource",),
        ),
        migrations.CreateModel(
            name="Catalog",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("title", models.CharField(max_length=255)),
                ("description", models.TextField()),
                (
                    "publisher",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="dcat.agent"
                    ),
                ),
                ("themes", models.ManyToManyField(to="dcat.datatheme")),
                (
                    "license",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dcat.licencedocument",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Distribution",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("title", models.CharField(blank=True, max_length=255)),
                ("description", models.TextField(blank=True)),
                ("file", models.FileField(upload_to="files/")),
                ("external_download_url", models.URLField(blank=True, null=True)),
                (
                    "license",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dcat.licencedocument",
                    ),
                ),
                (
                    "format",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="dcat.mediatype",
                    ),
                ),
                (
                    "dataset",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="dcat.dataset"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="dataset",
            name="catalog",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="dcat.catalog"
            ),
        ),
        migrations.AddField(
            model_name="dataset",
            name="publisher",
            field=models.ForeignKey(
                null=True, on_delete=django.db.models.deletion.SET_NULL, to="dcat.agent"
            ),
        ),
        migrations.AddField(
            model_name="dataset",
            name="themes",
            field=models.ManyToManyField(to="dcat.datatheme"),
        ),
    ]
